#  Predict the personality type from a candidate tweets.

import csv
import os

import pandas as pd
from future.moves import pickle

from preprocessor import pre_process_data
from preprocessor import translate_back

SAVE_MODEL = True
MODELS_DIR = "models"
SAMPLE_DATA_DIRECTORY = "data/sample_data"
SAMPLE_TWEETS_PATH = os.path.join(SAMPLE_DATA_DIRECTORY, "apihandyman_tweets.csv")

x_test = ""
DIMENSIONS = ["IE", "NS", "FT", "PJ"]

with open(SAMPLE_TWEETS_PATH, "r", encoding="ISO-8859-1") as f:
    reader = csv.reader(f)
    for row in f:
        # x_test.append(row)
        x_test = x_test + " " + row

type_indicators = ["IE: Introversion (I) - Extroversion (E)", "NS: Intuition (N) â Sensing (S)",
                   "FT: Feeling (F) - Thinking (T)", "JP: Judging (J) â Perceiving (P)"]

# The type is just a dummy so that the data preprocessing fucntion can be reused
mydata = pd.DataFrame(data={'type': ['ENFP'], 'posts': x_test})

x_test, dummy = pre_process_data(mydata, remove_stop_words=True)

result = []

# train type indicator individually
# for l in range(len(type_indicators)):
for k in range(len(DIMENSIONS)):
    print("%s ..." % (DIMENSIONS[k]))

    with open(os.path.join(MODELS_DIR, "sgd_pipeline_{}.pkl".format(DIMENSIONS[k])), 'rb') as picklefile:
        saved_pipe = pickle.load(picklefile)

    predictions = saved_pipe.predict(x_test)

    # make predictions for my  data
    result.append(predictions[0])

print("The result is: ", translate_back(result))
